<script setup lang="ts">
  const props = withDefaults(
    defineProps<{
      productId: string;
      controller?: ReturnType<typeof useModal>;
      static?: boolean;
    }>(),
    {
      static: false,
      controller: undefined,
    },
  );
  const { quickViewCmsPage, initQuickView, onQuickViewClosed, isQuickViewLoading } = useQuickView();

  onMounted(() => {
    initQuickView(props.productId);
  });

  onUnmounted(() => {
    onQuickViewClosed();
  });

  // const { getFormattedPrice } = usePrice();

  // const tierPrices = computed(() => getProductTierPrices(props.product));
  // const regularPrice = computed(
  //   () =>
  //     (tierPrices.value.length && tierPrices.value[0] && tierPrices.value[0].unitPrice) ||
  //     getProductCalculatedListingPrice(props.product),
  // );
  // const productName = computed(() => getTranslatedProperty(props.product, 'name'));
  // const manufacturerName = computed(() =>
  //   getTranslatedProperty(props.product.manufacturer, 'name'),
  // );

  // const productDescription = computed(() => getTranslatedProperty(props.product, 'description'));
  // const packUnit = computed(() => getTranslatedProperty(props.product, 'packUnit'));
  // const packUnitPlural = computed(() => getTranslatedProperty(props.product, 'packUnitPlural'));

  // const deliveryTime = computed(() => getTranslatedProperty(props.product.deliveryTime, 'name'));
</script>

<template>
  <SwModal
    panel-class="!w-90vw xl:!w-[75rem] 4xl:!w-[96rem]"
    :controller="controller"
    :modal-title="$t('presentation.details')"
    backdrop-display="static"
  >
    <template #body>
      <SwLoading v-if="isQuickViewLoading" />
      <template v-else>
        <!-- <div
          v-if="isGuide"
          class="bg-background-raised mb-6 flex flex-wrap items-center rounded-md p-3 md:w-[64rem]"
        >
          <span class="i-sw-solid:users mr-1.5 text-sm/none"></span>
          <span class="mr-1.5 text-sm font-semibold">{{ $t('presentation.currentlyViewing') }}:</span>
          <span class="pt-3 text-sm md:pt-0">{{ mockUsersAreViewing.join(', ') }}</span>
        </div> -->
        <div v-if="static">quick view static modal here</div>
        <div v-else-if="quickViewCmsPage?.cmsPage">
          <CmsPage :key="quickViewCmsPage?.product?.id" :content="quickViewCmsPage.cmsPage" />
        </div>
      </template>
      <!-- <div class="flex flex-col md:flex-row">
        <slot name="product-gallery">
          <div class="flex-1">Product gallery</div>
        </slot>
        <slot name="product-buy-box">
          <div class="flex flex-1 flex-col space-y-8 py-8">
            <slot name="product-name">
              <div>
                <h3 class="text-[1.75rem]/8 font-bold">
                  {{ productName }}
                </h3>
                <span class="text-(sm/6 information-subdued) font-medium">
                  {{ manufacturerName }}
                </span>
              </div>
            </slot>
            <slot name="product-price">
              <div class="flex flex-col space-y-2 pt-4">
                <div class="text-3xl font-bold">
                  {{ getFormattedPrice(regularPrice) }}
                </div>
                <span v-if="product.purchaseUnit" class="text-(xs information-subdued)">
                  Content: 100 pieces (€0.88* / 1 peace)
                </span>
                <span class="text-(primary sm/6) py-1 font-medium">{{
                  $t('product.taxInfo')
                }}</span>
                <div v-if="deliveryTime" class="flex flex-row items-center">
                  <span class="i-sw-custom:indicator text-([0.625rem] green-900) mr-1"></span>
                  <span class="text-xs"
                    >{{ $t('product.available') }}, {{ $t('product.deliveryTime') }}
                    {{ deliveryTime }}</span
                  >
                </div>
              </div>
            </slot>

            <slot name="product-variants">
              <div>
                <span class="text-sm/6 font-bold">{{ $t('product.variant') }}</span>
                <div class="flex flex-row space-x-2 pt-2">
                  <SwButton size="large" class="!font-medium">Red</SwButton>
                  <SwButton variant="action" size="large" class="!font-medium">Blue</SwButton>
                  <SwButton variant="action" size="large" class="!font-medium">Green</SwButton>
                  <SwButton variant="action" size="large" class="!font-medium">Yellow</SwButton>
                </div>
              </div>
            </slot>

            <slot name="product-buy-button">
              <div class="flex flex-col">
                <div class="flex">
                  <SwButton variant="action" size="large" class="mr-3 flex-none !py-3"
                    >Quantity</SwButton
                  >
                  <SwButton size="large" class="flex-1 !py-3">{{
                    $t('product.buyButton')
                  }}</SwButton>
                </div>
                <div class="pt-6 text-xs">
                  <span class="font-medium">{{ $t('product.productNumber') }}: </span>
                  <span>{{ product.productNumber }}</span>
                  <p class="text-information-subdued pt-2">{{ $t('product.priceNote') }}</p>
                </div>
              </div>
            </slot>
          </div>
        </slot>
      </div> -->
    </template>
  </SwModal>
</template>
